/*****************************************************************************
 romdate.c

 Developed November 1991 by Larry Reeve

 A TurboC program to display the machine date and ROM-BIOS date.
*****************************************************************************/
#include <dos.h>

#define  BYTE       unsigned char
#define  ADSBYTE    BYTE far *
#define  WORD       unsigned int

#define  PC         0xFF
#define  PCXT       0xFE
#define  PCJR       0xFD
#define  PCAT       0xFC
#define  COMPAQ     0x2D
#define  COMPAQPLUS 0x9A


WORD main (void)
{
    ADSBYTE MachineID;
    ADSBYTE ROMDate;
    int  i;

    printf("ROMDATE 1.0 - Display machine type and ROM-BIOS date.");
    printf("\n");

    /****************/
    /* Machine Type */
    /****************/
    printf("\nMachine type is ");
    MachineID = MK_FP(0xF000,0xFFFE);
    if (*MachineID == PC)
      printf("IBM-PC or Compatible");
    else if (*MachineID == PCXT)
      printf("IBM-PC/XT or Compatible");
    else if (*MachineID == PCAT)
      printf("IBM-PC/AT or Compatible");
    else if (*MachineID == PCJR)
      printf("IBM-PC/JR or Compatible");
    else if (*MachineID == COMPAQ)
      printf("Compaq or Compatible");
    else if (*MachineID == COMPAQPLUS)
      printf("Compaq Plus or Compatible");
    else
      printf("unknown! (0x%2x)",*MachineID);

    /****************/
    /* ROM Date     */
    /****************/
    printf("\nROM-BIOS is dated ");
    ROMDate = MK_FP(0xF000,0xFFF5);
    for (i=0; i < 8; i++)
      {
      printf("%c",*ROMDate);
      ROMDate++;
      }
    printf("\n");
    return (0);
}
